from network_socket import NetworkSocket

eth1610 = NetworkSocket()

#These will be the relays

def connect(ip, port, password):
    return eth1610.connect_socket(ip, port, password)

def disconnect():
    eth1610.close_socket()

def digital_command(command):

    parts = command.split(" ")     # Seperate the parts of the command
    message = None

    if parts[1] == "on":           # Are we turning the relay on or off
        message = '\x20'
    else:
        message = '\x21'

    message += chr(int(parts[0]))  # Which relay is it

    message += '\x00'              # 0 pulse time

    eth1610.write(message)         # send command and read back responce byte
    eth1610.read(1)

def get_states():
    command = '\x24'
    eth1610.write(command)          # send command and read back responce byte
    states = eth1610.read(2)
    st_str1 = ''.join('{0:02b}'.format(states[1], 'b'))
    st_str2 = ''.join('{0:08b}'.format(states[0], 'b'))
    print('Relay states 10->1 : ' + st_str1 + ' ' + st_str2)

    command = '\x25'
    eth1610.write(command)
    states = eth1610.read(2)
    st_str1 = ''.join('{0:08b}'.format(states[1], 'b'))
    st_str2 = ''.join('{0:08b}'.format(states[0], 'b'))
    print('Digital input states 16->1 : ' + st_str1 + ' ' + st_str2)


    for index in range(1, 16):   # Get Analogue values
        command = '\x32'+chr(index)
        eth1610.write(command)
        an = bytearray(eth1610.read(2))
        val = an[0] << 8 | an[1]
        print('Analogue input {:d}: {:d}'.format(index, val))
